
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	TOKEN	273
#define	NUMBER	274
#define	TYPETOKEN	275
#define	ARRAY_DIM	276
#define	CCODE	277
#define	HTCODE	278
#define	PHCODE	279
#define	HCODE	280
#define	ACODE	281
#define	ATCODE	282
#define	PUBLIC	283
#define	PRIVATE	284
#define	PROTECTED	285
#define	CLASSWIDE	286
#define	ARGUMENT	287
#define	VIRTUAL	288
#define	SIGNAL	289
#define	OVERRIDE	290

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "treefuncs.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;
char *chunk_size = NULL;

static GList *typestack = NULL;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

/* destructor and initializer for variables */
static char *destructor = NULL;
static int destructor_line = 0;
static gboolean destructor_simple = TRUE;
static char *initializer = NULL;
static int initializer_line = 0;

static char *onerror = NULL;
static char *defreturn = NULL;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ", str, " at end of input", NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp, '\n')))
			*p='.';

		out=g_strconcat("Error: ", str, " before '", tmp, "'", NULL);
		g_free(tmp);
	}

	fprintf(stderr, "%s:%d: %s\n", filename, line_no, out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope, type, name, line_no,
			   destructor, destructor_line,
			   destructor_simple,
			   initializer, initializer_line);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id,
	      GString *cbuf, int line_no, int ccode_line,
	      gboolean vararg, GList *flags)
{
	Node *node;
	Type *type;
	char *c_cbuf;

	g_assert(scope != CLASS_SCOPE);
       
	if(method == INIT_METHOD || method == CLASS_INIT_METHOD) {
		type = (Type *)new_type(g_strdup("void"), NULL, NULL);
	} else {
		type = pop_type();
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data, "NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"), line_no);
	}
	if(g_list_length(gtktypes) > 2) {
		GList *li;
		for(li = gtktypes->next; li; li = li->next) {
			if(strcmp(li->data, "NONE")==0) {
				print_error(FALSE,
					    _("NONE can only appear in an "
					      "argument list by itself"),
					    line_no);
			}
		}
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope, method, type, oid, gtktypes, flags,
			  id, funcargs, onerror, defreturn, c_cbuf, line_no,
			  ccode_line, vararg, method_unique_id++);

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	onerror = NULL;
	defreturn = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
free_all_global_state(void)
{
	g_free(onerror);
	onerror = NULL;
	g_free(defreturn);
	defreturn = NULL;

	g_free(chunk_size);
	chunk_size = NULL;
	
	g_list_foreach(gtktypes, (GFunc)g_free, NULL);
	g_list_free(gtktypes);
	gtktypes = NULL;

	free_node_list(funcargs);
	funcargs = NULL;
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type, name, checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(tn, g_strdup("*"), NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(g_strdup(((Class *)class)->otype), g_strdup("*"), NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}

static Variable *
find_var_or_die(const char *id, int line)
{
	GList *li;
	char *s;

	for(li = class_nodes; li != NULL; li = li->next) {
		Variable *var;
		Node *node = li->data;
		if(node->type != VARIABLE_NODE)
			continue;
		var = li->data;
		if(strcmp(var->id, id)==0)
			return var;
	}

	s = g_strdup_printf(_("Variable %s not defined here"), id);
	print_error(FALSE, s, line);

	g_assert_not_reached();
	return NULL;
}

static gboolean
set_return_value(char *type, char *val)
{
	if(strcmp(type, "onerror")==0) {
		if(!onerror) {
			onerror = val;
			return TRUE;
		} else
			return FALSE;
	} else if(strcmp(type, "defreturn")==0) {
		if(!defreturn) {
			defreturn = val;
			return TRUE;
		} else
			return FALSE;
	}
	return FALSE;
}


#line 294 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		256
#define	YYFLAG		-32768
#define	YYNTBASE	50

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 88)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    48,     2,     2,     2,     2,     2,     2,    39,
    40,    44,     2,    45,    49,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    41,    47,
    42,    46,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    37,    43,    38,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    22,
    24,    27,    29,    34,    38,    44,    45,    50,    55,    58,
    60,    62,    64,    66,    68,    70,    72,    74,    76,    79,
    83,    86,    90,    93,    96,    98,   100,   101,   107,   114,
   126,   135,   141,   147,   149,   153,   154,   158,   160,   163,
   165,   167,   169,   172,   175,   178,   182,   186,   189,   192,
   195,   197,   200,   202,   205,   207,   209,   211,   213,   215,
   217,   219,   221,   223,   225,   227,   229,   231,   234,   237,
   241,   244,   246,   250,   254,   257,   259,   264,   268,   270,
   273,   275,   286,   298,   308,   318,   327,   339,   348,   354,
   357,   362,   363,   365,   368,   370,   372,   376,   378,   382,
   384,   388,   390,   393,   397,   404,   412,   415,   417,   419,
   422,   425,   429,   433,   437,   441,   443,   446
};

static const short yyrhs[] = {    52,
    53,    52,     0,    53,    52,     0,    52,    53,     0,    53,
     0,    23,     0,    26,     0,    24,     0,    25,     0,    27,
     0,    28,     0,    52,    51,     0,    51,     0,    54,    37,
    56,    38,     0,    54,    37,    38,     0,     3,    21,     4,
    21,    55,     0,     0,    39,    19,    19,    40,     0,    39,
    19,    20,    40,     0,    56,    57,     0,    57,     0,    78,
     0,    62,     0,    63,     0,    41,     0,    29,     0,    30,
     0,    31,     0,    32,     0,    19,    19,     0,    19,    37,
    23,     0,    42,    87,     0,    42,    37,    23,     0,    59,
    60,     0,    60,    59,     0,    60,     0,    59,     0,     0,
    58,    67,    19,    61,    41,     0,    58,    67,    19,    22,
    61,    41,     0,    33,    65,    64,    19,    19,    37,    23,
    19,    37,    23,    41,     0,    33,    65,    64,    19,    19,
    37,    23,    41,     0,    33,    65,    64,    19,    19,     0,
    19,    39,    19,    67,    40,     0,    19,     0,    39,    66,
    40,     0,     0,    19,    43,    66,     0,    19,     0,    68,
    72,     0,    68,     0,    69,     0,    19,     0,     5,    19,
     0,    19,     5,     0,    71,    19,     0,     5,    71,    19,
     0,    71,    19,     5,     0,    70,    69,     0,    21,    69,
     0,     5,    69,     0,    21,     0,    21,     5,     0,    70,
     0,    70,     5,     0,     6,     0,    18,     0,    14,     0,
    15,     0,    13,     0,    16,     0,    17,     0,    11,     0,
    12,     0,     7,     0,     8,     0,     9,     0,    44,     0,
    44,     5,     0,    44,    72,     0,    44,     5,    72,     0,
    19,    75,     0,    75,     0,    58,    19,    75,     0,    19,
    58,    75,     0,    58,    75,     0,    73,     0,    19,    39,
    76,    40,     0,    76,    45,    19,     0,    19,     0,    37,
    23,     0,    41,     0,    35,    65,    74,    67,    19,    39,
    81,    40,    79,    77,     0,    58,    35,    65,    73,    67,
    19,    39,    81,    40,    79,    77,     0,    34,    58,    67,
    19,    39,    81,    40,    79,    77,     0,    58,    34,    67,
    19,    39,    81,    40,    79,    77,     0,    34,    67,    19,
    39,    81,    40,    79,    77,     0,    36,    39,    21,    40,
    67,    19,    39,    81,    40,    79,    77,     0,    58,    67,
    19,    39,    81,    40,    79,    77,     0,    19,    39,    19,
    40,    77,     0,    19,    80,     0,    19,    80,    19,    80,
     0,     0,    87,     0,    37,    23,     0,     6,     0,    19,
     0,    19,    45,    82,     0,    82,     0,    83,    45,    10,
     0,    83,     0,    83,    45,    84,     0,    84,     0,    67,
    19,     0,    67,    19,    22,     0,    67,    19,    39,    19,
    85,    40,     0,    67,    19,    22,    39,    19,    85,    40,
     0,    85,    86,     0,    86,     0,    19,     0,    46,    87,
     0,    47,    87,     0,    46,    42,    87,     0,    47,    42,
    87,     0,    42,    42,    87,     0,    48,    42,    87,     0,
    20,     0,    49,    20,     0,    19,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   312,   313,   314,   315,   318,   324,   330,   336,   342,   348,
   356,   357,   360,   365,   372,   377,   378,   386,   397,   398,
   401,   402,   403,   404,   407,   408,   409,   410,   413,   426,
   442,   446,   454,   455,   456,   457,   458,   464,   467,   471,
   506,   534,   604,   613,   619,   620,   623,   626,   632,   636,
   643,   646,   649,   653,   657,   661,   666,   674,   678,   683,
   687,   690,   694,   697,   702,   703,   704,   705,   706,   707,
   708,   709,   710,   713,   714,   715,   718,   719,   720,   724,
   731,   743,   749,   761,   773,   776,   782,   787,   790,   795,
   796,   800,   816,   832,   848,   864,   875,   881,   891,   914,
   925,   944,   950,   951,   957,   958,   969,   979,   982,   983,
   986,   987,   990,   993,   996,  1004,  1014,  1015,  1018,  1031,
  1035,  1039,  1043,  1047,  1051,  1057,  1058,  1062
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","TOKEN","NUMBER","TYPETOKEN","ARRAY_DIM",
"CCODE","HTCODE","PHCODE","HCODE","ACODE","ATCODE","PUBLIC","PRIVATE","PROTECTED",
"CLASSWIDE","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE","'{'","'}'","'('","')'",
"';'","'='","'|'","'*'","','","'>'","'<'","'!'","'-'","prog","ccode","ccodes",
"class","classdec","chunk","classcode","thing","scope","destructor","initializer",
"varoptions","variable","argument","argtype","flags","flaglist","type","specifier_list",
"spec_list","specifier","strunionenum","pointer","simplesigtype","fullsigtype",
"sigtype","tokenlist","codenocode","method","returnvals","retcode","funcargs",
"arglist","arglist1","arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    50,    50,    50,    50,    51,    51,    51,    51,    51,    51,
    52,    52,    53,    53,    54,    55,    55,    55,    56,    56,
    57,    57,    57,    57,    58,    58,    58,    58,    59,    59,
    60,    60,    61,    61,    61,    61,    61,    62,    62,    63,
    63,    63,    64,    64,    65,    65,    66,    66,    67,    67,
    68,    68,    68,    68,    68,    68,    68,    69,    69,    69,
    69,    69,    69,    69,    70,    70,    70,    70,    70,    70,
    70,    70,    70,    71,    71,    71,    72,    72,    72,    72,
    73,    73,    74,    74,    74,    74,    75,    76,    76,    77,
    77,    78,    78,    78,    78,    78,    78,    78,    78,    79,
    79,    79,    80,    80,    81,    81,    81,    81,    82,    82,
    83,    83,    84,    84,    84,    84,    85,    85,    86,    86,
    86,    86,    86,    86,    86,    87,    87,    87
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     4,     3,     5,     0,     4,     4,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     3,
     2,     3,     2,     2,     1,     1,     0,     5,     6,    11,
     8,     5,     5,     1,     3,     0,     3,     1,     2,     1,
     1,     1,     2,     2,     2,     3,     3,     2,     2,     2,
     1,     2,     1,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     2,     2,     3,
     2,     1,     3,     3,     2,     1,     4,     3,     1,     2,
     1,    10,    11,     9,     9,     8,    11,     8,     5,     2,
     4,     0,     1,     2,     1,     1,     3,     1,     3,     1,
     3,     1,     2,     3,     6,     7,     2,     1,     1,     2,
     2,     3,     3,     3,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,     9,    10,    12,     0,     4,
     0,     0,    11,     3,     2,     0,     0,     1,     0,    25,
    26,    27,    28,    46,     0,    46,     0,    14,    24,     0,
    20,     0,    22,    23,    21,    16,     0,     0,     0,     0,
    65,    74,    75,    76,    72,    73,    69,    67,    68,    70,
    71,    66,    52,    61,     0,     0,    50,    51,    63,     0,
     0,     0,    13,    19,     0,    46,     0,     0,    15,     0,
    48,     0,    44,     0,     0,    53,    60,     0,    54,    62,
    59,     0,     0,    77,    49,    64,    58,    55,     0,     0,
    86,     0,    82,     0,     0,     0,    37,     0,     0,     0,
    45,     0,     0,    56,     0,     0,    78,    79,    57,     0,
     0,     0,    81,     0,    85,     0,     0,     0,     0,     0,
     0,    37,     0,     0,    36,    35,     0,     0,     0,     0,
    91,    99,    47,     0,    42,     0,    65,    52,     0,     0,
   108,   110,   112,    80,    89,     0,    84,    83,     0,     0,
     0,     0,    29,     0,     0,     0,   128,   126,     0,     0,
    31,    33,    34,    38,    17,    18,    90,     0,     0,     0,
     0,   113,   102,     0,    87,     0,     0,     0,     0,     0,
    30,    39,   102,    32,   127,    43,     0,   102,   107,   114,
     0,     0,     0,   109,   111,    88,     0,     0,   102,     0,
     0,     0,    41,     0,     0,     0,     0,   100,   103,    96,
   102,     0,     0,     0,    98,     0,    94,     0,   119,     0,
     0,     0,     0,     0,   118,   104,     0,     0,   102,    95,
   102,     0,     0,     0,     0,   120,     0,   121,     0,   115,
   117,   101,    92,     0,     0,    40,   116,   124,   122,   123,
   125,    97,    93,     0,     0,     0
};

static const short yydefgoto[] = {   254,
     8,     9,    10,    11,    69,    30,    31,    32,   125,   126,
   127,    33,    34,    74,    39,    72,   139,    57,    58,    59,
    60,    85,    91,    92,    93,   146,   132,    35,   193,   208,
   140,   141,   142,   143,   224,   225,   209
};

static const short yypact[] = {   174,
    -1,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   174,   221,
   -14,    38,-32768,   221,   221,   175,    23,   221,    29,-32768,
-32768,-32768,-32768,    39,   157,    39,    41,-32768,-32768,   193,
-32768,   112,-32768,-32768,-32768,    57,    72,    81,    84,   263,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    99,   314,   280,    89,    90,-32768,   328,   117,
   161,   116,-32768,-32768,   280,    39,   119,   123,-32768,   104,
   105,   114,   118,   133,   342,-32768,-32768,   137,-32768,   342,
-32768,   139,   128,     5,-32768,   342,-32768,   176,   211,   160,
-32768,   280,-32768,   142,   164,   165,    67,     6,    17,    81,
-32768,   166,   177,-32768,   156,   297,    90,-32768,-32768,   178,
   184,   195,-32768,    31,-32768,   196,   280,   179,    31,   280,
    -2,   -15,   297,    44,   190,   200,   180,   197,   198,   210,
-32768,-32768,-32768,   280,   183,   297,   199,     3,   216,   226,
-32768,   191,-32768,-32768,-32768,    42,-32768,-32768,   234,   264,
   297,   271,-32768,   277,   266,   281,-32768,-32768,   294,   302,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   283,   301,   296,
   280,    51,   318,   246,-32768,   319,   297,   311,   312,   322,
-32768,-32768,   318,-32768,-32768,-32768,    -3,   318,-32768,   323,
   332,    46,    17,-32768,-32768,-32768,   324,   297,   318,   297,
    17,   329,-32768,    17,   346,    93,   344,   349,-32768,-32768,
   318,   330,    17,   331,-32768,   350,-32768,    93,-32768,   327,
    52,    65,   333,   103,-32768,-32768,    46,    17,   318,-32768,
   318,   335,   113,    56,    56,-32768,    56,-32768,    56,-32768,
-32768,-32768,-32768,    17,    17,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   372,   374,-32768
};

static const short yypgoto[] = {-32768,
    13,    78,   368,-32768,-32768,-32768,   348,   -22,   253,   255,
   259,-32768,-32768,-32768,   -20,   282,   -18,-32768,   -35,-32768,
   343,   -73,   288,-32768,   -57,-32768,  -192,-32768,  -170,   158,
  -121,   215,-32768,   213,   170,  -164,  -124
};


#define	YYLAST		388


static const short yytable[] = {   161,
   210,   156,    55,   121,    77,    61,    56,    79,   215,   107,
   108,   217,   201,    67,   170,   202,   153,   204,    81,    12,
   230,    13,    16,    87,   128,   129,   124,    13,   213,   179,
    13,   113,   115,   144,   154,   243,    82,   203,    90,    77,
   228,    17,  -106,    36,    77,    96,    95,   171,    84,   110,
    77,   252,   253,   130,   147,   197,   148,   131,   244,   241,
   245,   113,   157,   158,   157,   158,   112,    37,   241,   111,
   157,   158,   190,   116,   157,   158,   212,    38,   214,    62,
   159,   175,   207,   157,   158,   121,   176,    15,   122,   191,
    70,    18,   160,   235,   160,    68,   236,   238,   150,    71,
   160,   152,    73,    79,   160,   123,   237,    83,   124,   248,
   249,   219,   250,   160,   251,   168,    40,    41,    42,    43,
    44,   219,    45,    46,    47,    48,    49,    50,    51,    52,
    53,   219,    54,    84,   220,    88,    94,    97,   221,   222,
   223,    98,   240,    99,   220,    65,    66,   100,   221,   222,
   223,   103,   247,   101,   220,   104,   102,   105,   221,   222,
   223,    40,    41,    42,    43,    44,   106,    45,    46,    47,
    48,    49,    50,    51,    52,    53,     1,    54,   114,    89,
   109,   117,   118,   119,   134,    20,    21,    22,    23,    20,
    21,    22,    23,    19,   136,   135,     2,     3,     4,     5,
     6,     7,   145,    20,    21,    22,    23,    24,    25,    26,
    27,    19,    28,   110,   149,    29,   111,   151,   121,   169,
   164,    20,    21,    22,    23,    24,    25,    26,    27,   110,
    63,   124,   167,    29,   172,   174,   165,   166,  -105,    20,
    21,    22,    23,     2,     3,     4,     5,     6,     7,   111,
    40,    41,    42,    43,    44,   194,    45,    46,    47,    48,
    49,    50,    51,    52,    53,   173,    54,    75,    41,    42,
    43,    44,   177,    45,    46,    47,    48,    49,    50,    51,
    52,    76,   178,    54,    40,    41,    42,    43,    44,   180,
    45,    46,    47,    48,    49,    50,    51,    52,    53,   181,
    54,    40,   137,    42,    43,    44,   182,    45,    46,    47,
    48,    49,    50,    51,    52,   138,   184,    54,    80,    41,
   183,   185,   186,   187,    45,    46,    47,    48,    49,    50,
    51,    52,    86,    41,    54,   188,   192,   196,    45,    46,
    47,    48,    49,    50,    51,    52,    75,    41,    54,   198,
   206,   199,    45,    46,    47,    48,    49,    50,    51,    52,
   200,   205,    54,   211,   218,   216,   226,   227,   234,   229,
   231,   255,   232,   256,   239,   246,    14,    64,   163,   162,
   155,   133,    78,   120,   242,   189,   195,   233
};

static const short yycheck[] = {   124,
   193,   123,    25,    19,    40,    26,    25,     5,   201,     5,
    84,   204,   183,    32,   136,    19,    19,   188,    54,    21,
   213,     9,    37,    59,    19,    20,    42,    15,   199,   151,
    18,    89,    90,   107,    37,   228,    55,    41,    61,    75,
   211,     4,    40,    21,    80,    66,    65,    45,    44,    19,
    86,   244,   245,    37,   112,   177,   114,    41,   229,   224,
   231,   119,    19,    20,    19,    20,    89,    39,   233,    39,
    19,    20,    22,    92,    19,    20,   198,    39,   200,    39,
    37,    40,    37,    19,    20,    19,    45,    10,    22,    39,
    19,    14,    49,    42,    49,    39,   221,   222,   117,    19,
    49,   120,    19,     5,    49,    39,    42,    19,    42,   234,
   235,    19,   237,    49,   239,   134,     5,     6,     7,     8,
     9,    19,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    19,    21,    44,    42,    19,    21,    19,    46,    47,
    48,    19,    40,    40,    42,    34,    35,    43,    46,    47,
    48,    19,    40,    40,    42,    19,    39,    19,    46,    47,
    48,     5,     6,     7,     8,     9,    39,    11,    12,    13,
    14,    15,    16,    17,    18,    19,     3,    21,    19,    19,
     5,    40,    19,    19,    19,    29,    30,    31,    32,    29,
    30,    31,    32,    19,    39,    19,    23,    24,    25,    26,
    27,    28,    19,    29,    30,    31,    32,    33,    34,    35,
    36,    19,    38,    19,    19,    41,    39,    39,    19,    37,
    41,    29,    30,    31,    32,    33,    34,    35,    36,    19,
    38,    42,    23,    41,    19,    45,    40,    40,    40,    29,
    30,    31,    32,    23,    24,    25,    26,    27,    28,    39,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    40,    21,     5,     6,     7,
     8,     9,    39,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    19,    21,     5,     6,     7,     8,     9,    19,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    23,
    21,     5,     6,     7,     8,     9,    41,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    23,    21,     5,     6,
    40,    20,    40,    23,    11,    12,    13,    14,    15,    16,
    17,    18,     5,     6,    21,    40,    19,    19,    11,    12,
    13,    14,    15,    16,    17,    18,     5,     6,    21,    39,
    19,    40,    11,    12,    13,    14,    15,    16,    17,    18,
    39,    39,    21,    40,    19,    37,    23,    19,    42,    40,
    40,     0,    23,     0,    42,    41,     9,    30,   126,   125,
   122,   100,    40,    96,   227,   171,   174,   218
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 312 "parse.y"
{ ; ;
    break;}
case 2:
#line 313 "parse.y"
{ ; ;
    break;}
case 3:
#line 314 "parse.y"
{ ; ;
    break;}
case 4:
#line 315 "parse.y"
{ ; ;
    break;}
case 5:
#line 318 "parse.y"
{
			Node *node = new_ccode(C_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 324 "parse.y"
{
			Node *node = new_ccode(H_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 330 "parse.y"
{
			Node *node = new_ccode(HT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 336 "parse.y"
{
			Node *node = new_ccode(PH_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 342 "parse.y"
{
			Node *node = new_ccode(A_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 10:
#line 348 "parse.y"
{
			Node *node = new_ccode(AT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 11:
#line 356 "parse.y"
{ ; ;
    break;}
case 12:
#line 357 "parse.y"
{ ; ;
    break;}
case 13:
#line 360 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 14:
#line 365 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 15:
#line 372 "parse.y"
{
			class = new_class(yyvsp[-3].id,yyvsp[-1].id,chunk_size,NULL);
						;
    break;}
case 17:
#line 378 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"chunks") == 0) {
					chunk_size = g_strdup(yyvsp[0].id);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
		;
    break;}
case 18:
#line 386 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"chunks") == 0) {
				if(atoi(yyvsp[0].id) != 0)
					chunk_size = g_strdup(yyvsp[0].id);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
		;
    break;}
case 19:
#line 397 "parse.y"
{ ; ;
    break;}
case 20:
#line 398 "parse.y"
{ ; ;
    break;}
case 21:
#line 401 "parse.y"
{ ; ;
    break;}
case 22:
#line 402 "parse.y"
{ ; ;
    break;}
case 23:
#line 403 "parse.y"
{ ; ;
    break;}
case 24:
#line 404 "parse.y"
{ ; ;
    break;}
case 25:
#line 407 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 26:
#line 408 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 27:
#line 409 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 28:
#line 410 "parse.y"
{ the_scope = CLASS_SCOPE; ;
    break;}
case 29:
#line 413 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "destroywith")==0) {
				g_free(yyvsp[-1].id);
				destructor = yyvsp[0].id;
				destructor_line = line_no;
				destructor_simple = TRUE;
			} else {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
				;
    break;}
case 30:
#line 426 "parse.y"
{
			if(strcmp(yyvsp[-2].id, "destroy")==0) {
				g_free(yyvsp[-2].id);
				destructor = (yyvsp[0].cbuf)->str;
				g_string_free(yyvsp[0].cbuf, FALSE);
				destructor_line = ccode_line;
				destructor_simple = FALSE;
			} else {
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf, TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 31:
#line 442 "parse.y"
{
			initializer = yyvsp[0].id;
			initializer_line = ccode_line;
				;
    break;}
case 32:
#line 446 "parse.y"
{
			initializer = (yyvsp[0].cbuf)->str;
			initializer_line = ccode_line;
			g_string_free(yyvsp[0].cbuf, FALSE);
				;
    break;}
case 33:
#line 454 "parse.y"
{ ; ;
    break;}
case 34:
#line 455 "parse.y"
{ ; ;
    break;}
case 35:
#line 456 "parse.y"
{ destructor = NULL; ;
    break;}
case 36:
#line 457 "parse.y"
{ initializer = NULL; ;
    break;}
case 37:
#line 458 "parse.y"
{
			destructor = NULL;
			initializer = NULL;
					;
    break;}
case 38:
#line 464 "parse.y"
{
			push_variable(yyvsp[-2].id, the_scope,yyvsp[-4].line, NULL);
						;
    break;}
case 39:
#line 467 "parse.y"
{
			push_variable(yyvsp[-3].id, the_scope, yyvsp[-5].line, yyvsp[-2].id);
						;
    break;}
case 40:
#line 471 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 41:
#line 506 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    NULL,0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,(yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 42:
#line 534 "parse.y"
{
			Node *node;
			char *get, *set = NULL;
			Variable *var;
			Type *type;
			char *root;
			
			if(strcmp(yyvsp[0].id, "link")!=0 &&
			   strcmp(yyvsp[0].id, "stringlink")!=0 &&
			   strcmp(yyvsp[0].id, "objectlink")!=0) {
				g_free(yyvsp[0].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id);
				g_list_foreach(yyvsp[-3].list,(GFunc)g_free,NULL);
				yyerror(_("parse error"));
				YYERROR;
			}

			type = pop_type();

			var = find_var_or_die(yyvsp[-1].id, yyvsp[-4].line);
			if(var->scope == PRIVATE_SCOPE)
				root = "self->_priv";
			else if(var->scope == CLASS_SCOPE)
				root = "SELF_CLASS(GTK_OBJECT(self)->klass)";
			else
				root = "self";

			if(strcmp(yyvsp[0].id, "link")==0) {
				set = g_strdup_printf("%s->%s = ARG;",
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id, "stringlink")==0) {
				set = g_strdup_printf("g_free(%s->%s); "
						      "%s->%s = g_strdup(ARG);",
						      root, yyvsp[-1].id,
						      root, yyvsp[-1].id);
			} else if(strcmp(yyvsp[0].id, "objectlink")==0) {
				set = g_strdup_printf(
				  "if(%s->%s) "
				   "gtk_object_unref(GTK_OBJECT(%s->%s)); "
				  "%s->%s = ARG; "
				  "if(%s->%s) "
				   "gtk_object_ref(GTK_OBJECT(%s->%s));",
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id,
				  root, yyvsp[-1].id);
			} else {
				g_assert_not_reached();
			}

			if(strcmp(yyvsp[0].id, "stringlink")==0) {
				get = g_strdup_printf("ARG = g_strdup(%s->%s);", root, yyvsp[-1].id);
			} else
				/* For everything else, get is just straight assignment */
				get = g_strdup_printf("ARG = %s->%s;", root, yyvsp[-1].id);

			g_free(yyvsp[0].id);


			if(!type)
				type = copy_type(var->vtype);

			node = new_argument(yyvsp[-2].id, type, yyvsp[-3].list,
					    yyvsp[-1].id, get, yyvsp[-4].line,
					    set, yyvsp[-4].line, yyvsp[-4].line);
			class_nodes = g_list_append(class_nodes,node);
						;
    break;}
case 43:
#line 604 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 44:
#line 613 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 45:
#line 619 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 46:
#line 620 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 47:
#line 623 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 48:
#line 626 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 49:
#line 632 "parse.y"
{
			Node *node = new_type(yyvsp[-1].id, yyvsp[0].id, NULL);
			typestack = g_list_prepend(typestack,node);
							;
    break;}
case 50:
#line 636 "parse.y"
{
			Node *node = new_type(yyvsp[0].id, NULL, NULL);
			typestack = g_list_prepend(typestack,node);
							;
    break;}
case 51:
#line 643 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 52:
#line 646 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 53:
#line 649 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 54:
#line 653 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 55:
#line 657 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 56:
#line 661 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[-1].id, " ",
					     yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 57:
#line 666 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-2].id, " ",
					     yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 58:
#line 674 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 59:
#line 678 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " ", yyvsp[0].id, NULL);
			g_free(yyvsp[-1].id);
			g_free(yyvsp[0].id);
							;
    break;}
case 60:
#line 683 "parse.y"
{
			yyval.id = g_strconcat("const ", yyvsp[0].id, NULL);
			g_free(yyvsp[0].id);
							;
    break;}
case 61:
#line 687 "parse.y"
{
			yyval.id = yyvsp[0].id;
							;
    break;}
case 62:
#line 690 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
			g_free(yyvsp[-1].id);
							;
    break;}
case 63:
#line 694 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
							;
    break;}
case 64:
#line 697 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id, " const", NULL);
							;
    break;}
case 65:
#line 702 "parse.y"
{ yyval.id = "void"; ;
    break;}
case 66:
#line 703 "parse.y"
{ yyval.id = "char"; ;
    break;}
case 67:
#line 704 "parse.y"
{ yyval.id = "short"; ;
    break;}
case 68:
#line 705 "parse.y"
{ yyval.id = "int"; ;
    break;}
case 69:
#line 706 "parse.y"
{ yyval.id = "long"; ;
    break;}
case 70:
#line 707 "parse.y"
{ yyval.id = "float"; ;
    break;}
case 71:
#line 708 "parse.y"
{ yyval.id = "double"; ;
    break;}
case 72:
#line 709 "parse.y"
{ yyval.id = "signed"; ;
    break;}
case 73:
#line 710 "parse.y"
{ yyval.id = "unsigned"; ;
    break;}
case 74:
#line 713 "parse.y"
{ yyval.id = "struct"; ;
    break;}
case 75:
#line 714 "parse.y"
{ yyval.id = "union"; ;
    break;}
case 76:
#line 715 "parse.y"
{ yyval.id = "enum"; ;
    break;}
case 77:
#line 718 "parse.y"
{ yyval.id = g_strdup("*"); ;
    break;}
case 78:
#line 719 "parse.y"
{ yyval.id = g_strdup("* const"); ;
    break;}
case 79:
#line 720 "parse.y"
{
				yyval.id = g_strconcat("*", yyvsp[0].id, NULL);
				g_free(yyvsp[0].id);
					;
    break;}
case 80:
#line 724 "parse.y"
{
				yyval.id = g_strconcat("* const", yyvsp[0].id, NULL);
				g_free(yyvsp[0].id);
					;
    break;}
case 81:
#line 731 "parse.y"
{
			if(strcmp(yyvsp[-1].id, "first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id, "last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 82:
#line 743 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 83:
#line 749 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 84:
#line 761 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 85:
#line 773 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 86:
#line 776 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 87:
#line 782 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes, yyvsp[-3].id);
						;
    break;}
case 88:
#line 787 "parse.y"
{
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
						;
    break;}
case 89:
#line 790 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes, yyvsp[0].id);
       						;
    break;}
case 90:
#line 795 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 91:
#line 796 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 92:
#line 800 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 93:
#line 816 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 94:
#line 832 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-8].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 95:
#line 848 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 96:
#line 864 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				free_all_global_state();
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 97:
#line 875 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[0].cbuf,
				      yyvsp[-10].line, ccode_line,
				      vararg, NULL);
									;
    break;}
case 98:
#line 881 "parse.y"
{
			if(the_scope == CLASS_SCOPE) {
				yyerror(_("a method cannot be of class scope"));
				free_all_global_state();
				YYERROR;
			}
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[0].cbuf, yyvsp[-7].line, ccode_line,
				      vararg, NULL);
								;
    break;}
case 99:
#line 891 "parse.y"
{
			if(strcmp(yyvsp[-4].id, "init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else if(strcmp(yyvsp[-4].id, "class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[0].cbuf,TRUE);
				yyerror(_("parse error "
					  "(untyped blocks must be init or "
					  "class_init)"));
				YYERROR;
			}
						;
    break;}
case 100:
#line 914 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				g_free(yyvsp[-1].id);
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 101:
#line 925 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
			if(!set_return_value(yyvsp[-3].id, yyvsp[-2].id)) {
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			if(!set_return_value(yyvsp[-1].id, yyvsp[0].id)) {
				onerror = defreturn = NULL;
				g_free(yyvsp[-3].id); g_free(yyvsp[-2].id);
				g_free(yyvsp[-1].id); g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-3].id);
			g_free(yyvsp[-1].id);
						;
    break;}
case 102:
#line 944 "parse.y"
{
			g_free(onerror); onerror = NULL;
			g_free(defreturn); defreturn = NULL;
					;
    break;}
case 103:
#line 950 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 104:
#line 951 "parse.y"
{
			yyval.id = (yyvsp[1].cbuf)->str;
			g_string_free(yyvsp[1].cbuf, FALSE);
					;
    break;}
case 105:
#line 957 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 106:
#line 958 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 107:
#line 969 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 108:
#line 979 "parse.y"
{ has_self = FALSE; ;
    break;}
case 109:
#line 982 "parse.y"
{ vararg = TRUE; ;
    break;}
case 110:
#line 983 "parse.y"
{ vararg = FALSE; ;
    break;}
case 111:
#line 986 "parse.y"
{ ; ;
    break;}
case 112:
#line 987 "parse.y"
{ ; ;
    break;}
case 113:
#line 990 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 114:
#line 993 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 115:
#line 996 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 116:
#line 1004 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 117:
#line 1014 "parse.y"
{ ; ;
    break;}
case 118:
#line 1015 "parse.y"
{ ; ;
    break;}
case 119:
#line 1018 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 120:
#line 1031 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 121:
#line 1035 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 122:
#line 1039 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 123:
#line 1043 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 124:
#line 1047 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 125:
#line 1051 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 126:
#line 1057 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 127:
#line 1058 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 128:
#line 1062 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1065 "parse.y"

